; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_BEGRUESSUNG:
	ldi temp1,BYTE1(2015)
	ldi temp2,BYTE2(2015)
	clr temp3
	clr temp4
 	rcall FUNKTION_HEX_ASC_32
	STS(adr_LED_BYTE_0), temp1	
	STS(adr_LED_BYTE_1), temp2
  	STS(adr_LED_BYTE_2), temp3
  	STS(adr_LED_BYTE_3), temp4
	rcall WAIT_100ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TEMPERATUR:
	; LADEN
    LDS temp1,(adr_TSIC_TEMPERATUR_L)
    LDS temp2,(adr_TSIC_TEMPERATUR_H)
	; negativ ? 
	tst temp2  
	brmi ANZEIGE_TEMPERATUR_NEGATIV
; ##############################################################################
ANZEIGE_TEMPERATUR_POSITIV:
	clr temp3
	clr temp4
 	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	ori temp2, 0b10000000		; PUNKT	
	rcall NULLSTELLENUNTERDRUECKUNG
    ; TEMPERATUR
	STS(adr_LED_BYTE_0), temp1	
	STS(adr_LED_BYTE_1), temp2
  	STS(adr_LED_BYTE_2), temp3
  	STS(adr_LED_BYTE_3), temp4
	ret
; ##############################################################################
ANZEIGE_TEMPERATUR_NEGATIV:
	; LADEN
    LDS temp1,(adr_TSIC_TEMPERATUR_L)
    LDS temp2,(adr_TSIC_TEMPERATUR_H)
	clr temp3
	clr temp4
	; mal "-1" 		
	com temp1
	com temp2
	add temp1,EINS
	adc temp2,NULL
	clr temp3
	clr temp4
;-------------------------------------------------------------------------------
 	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	ori temp2, 0b10000000        ; PUNKT	
	; TEMPERATUR
	STS(adr_LED_BYTE_0), temp1	
	STS(adr_LED_BYTE_1), temp2
	STS(adr_LED_BYTE_2), temp3
 	ldi temp, (ZEICHEN_MINUS)	; MINUS
  	STS(adr_LED_BYTE_3), temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_STROBE_A:
    LDS temp1,(adr_TSIC_STROBE)
	clr temp2
	clr temp3
	clr temp4
 	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	STS(adr_LED_BYTE_0), temp1	
	STS(adr_LED_BYTE_1), temp2
  	STS(adr_LED_BYTE_2), temp3
	ldi temp,(ZEICHEN_T)		; "t"		
	ori temp, 0b10000000		; "." PUNKT	
 	STS(adr_LED_BYTE_3), temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_STRICH:
	; LEDs				
	ldi temp, (ZEICHEN_MINUS)
	STS(adr_LED_BYTE_0),temp
	STS(adr_LED_BYTE_1),temp
	STS(adr_LED_BYTE_2),temp
	STS(adr_LED_BYTE_3),temp
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
;																			
;	Value: 0...	99.999.999													
;																			
;	INPUT: 	temp1	(BYTE1)													
;	 		temp2	(BYTE2)													
;			temp3	(BYTE3)													
;			temp4	(BYTE4)													
;																			
;	OUTPUT:	temp1	(		   1-er Stelle)									
;			temp2	(		  10-er Stelle)									
;			temp3	(        100-er Stelle)									
;			temp4	(      1.000-er Stelle)									
;			temp5	(     10.000-er Stelle)									
;			temp6	(    100.000-er Stelle)									
;			temp7	(  1.000.000-er Stelle)									
;			temp8	( 10.000.000-er Stelle)									
; 																			
; rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8			
; 																			
FUNKTION_HEX_ASC_32:
	clr temp
FUNKTION_HEX_ASC_10000000:; 10.000.000
	inc temp
	subi temp1, BYTE1    (10000000)
	sbci temp2, BYTE2    (10000000)
	sbci temp3, BYTE3    (10000000)
	sbci temp4, BYTE4    (10000000)
	brcc FUNKTION_HEX_ASC_10000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp8) auf dem Stack sichern            
	subi temp1, BYTE1   (-10000000)
	sbci temp2, BYTE2   (-10000000)
	sbci temp3, BYTE3   (-10000000)
	sbci temp4, BYTE4   (-10000000)
	clr temp
FUNKTION_HEX_ASC_1000000:
	inc temp
	subi temp1, BYTE1    (1000000)
	sbci temp2, BYTE2    (1000000)
	sbci temp3, BYTE3    (1000000)
	brcc FUNKTION_HEX_ASC_1000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp7) auf dem Stack sichern            
	subi temp1, BYTE1   (-1000000)
	sbci temp2, BYTE2   (-1000000)
	sbci temp3, BYTE3   (-1000000)
	clr temp
FUNKTION_HEX_ASC_100000:
	inc temp
	subi temp1, BYTE1    (100000)
	sbci temp2, BYTE2    (100000)
	sbci temp3, BYTE3    (100000)
	brcc FUNKTION_HEX_ASC_100000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp6) auf dem Stack sichern            
	subi temp1, BYTE1   (-100000)
	sbci temp2, BYTE2   (-100000)
	sbci temp3, BYTE3   (-100000)
	clr temp
FUNKTION_HEX_ASC_10000:
	inc temp
	subi temp1, BYTE1    (10000)
	sbci temp2, BYTE2    (10000)
	sbci temp3, BYTE3    (10000)
	brcc FUNKTION_HEX_ASC_10000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp5) auf dem Stack sichern            
	subi temp1, BYTE1  (-10000)
	sbci temp2, BYTE2  (-10000)
	sbci temp3, BYTE3  (-10000)
	clr temp
FUNKTION_HEX_ASC_1000:
	inc temp
	subi temp1, low  (1000)
	sbci temp2, HIGH (1000)
	brcc FUNKTION_HEX_ASC_1000
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp4) auf dem Stack sichern            
	subi temp1, low  (-1000)
	sbci temp2, HIGH (-1000)
	clr temp
FUNKTION_HEX_ASC_100:
	inc temp
	subi temp1, low  (100)
	sbci temp2, HIGH (100)
	brcc FUNKTION_HEX_ASC_100
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp3) auf dem Stack sichern            
	subi temp1, low  (-100)
	sbci temp2, HIGH (-100)
	clr temp
FUNKTION_HEX_ASC_10:
	inc temp
	subi temp1, low  (10)
	sbci temp2, HIGH (10)
	brcc FUNKTION_HEX_ASC_10
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp2) auf dem Stack sichern            
	subi temp1, low  (-10)
	sbci temp2, HIGH (-10)
FUNKTION_HEX_ASC_1:	
	subi temp1, -48		; HEX->ASC

	pop	TEMP2			; LESEN vom STACK (KOPIE)
	pop	TEMP3			; LESEN vom STACK (KOPIE)
	pop	TEMP4			; LESEN vom STACK (KOPIE)
	pop	TEMP5			; LESEN vom STACK (KOPIE)
	pop	TEMP6			; LESEN vom STACK (KOPIE)
	pop	TEMP7			; LESEN vom STACK (KOPIE)
	pop	TEMP8			; LESEN vom STACK (KOPIE)

	; auf 7 SEGNMENT
	mov temp,temp1
	rcall FUNKTION_7_SEGMENT
	mov temp1,temp

	mov temp,temp2
	rcall FUNKTION_7_SEGMENT
	mov temp2,temp


	mov temp,temp3
	rcall FUNKTION_7_SEGMENT
	mov temp3,temp

	mov temp,temp4
	rcall FUNKTION_7_SEGMENT
	mov temp4,temp

	mov temp,temp5
	rcall FUNKTION_7_SEGMENT
	mov temp5,temp

	mov temp,temp6
	rcall FUNKTION_7_SEGMENT
	mov temp6,temp

	mov temp,temp7
	rcall FUNKTION_7_SEGMENT
	mov temp7,temp

	mov temp,temp8
	rcall FUNKTION_7_SEGMENT
	mov temp8,temp

ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
FUNKTION_7_SEGMENT:
	cpi temp,'0'
	breq FUNKTION_7_SEGMENT_0
	cpi temp,'1'
	breq FUNKTION_7_SEGMENT_1
	cpi temp,'2'
	breq FUNKTION_7_SEGMENT_2
	cpi temp,'3'
	breq FUNKTION_7_SEGMENT_3
	cpi temp,'4'
	breq FUNKTION_7_SEGMENT_4
	cpi temp,'5'
	breq FUNKTION_7_SEGMENT_5
	cpi temp,'6'
	breq FUNKTION_7_SEGMENT_6
	cpi temp,'7'
	breq FUNKTION_7_SEGMENT_7
	cpi temp,'8'
	breq FUNKTION_7_SEGMENT_8
	cpi temp,'9'
	breq FUNKTION_7_SEGMENT_9
	; ERROR
	ldi temp, (ZEICHEN_E)
	ret
FUNKTION_7_SEGMENT_0:
	ldi temp, (ZAHL_0)
	ret
FUNKTION_7_SEGMENT_1:
	ldi temp, (ZAHL_1)
	ret
FUNKTION_7_SEGMENT_2:
	ldi temp, (ZAHL_2)
	ret
FUNKTION_7_SEGMENT_3:
	ldi temp, (ZAHL_3)
	ret
FUNKTION_7_SEGMENT_4:
	ldi temp, (ZAHL_4)
	ret
FUNKTION_7_SEGMENT_5:
	ldi temp, (ZAHL_5)
	ret
FUNKTION_7_SEGMENT_6:
	ldi temp, (ZAHL_6)
	ret
FUNKTION_7_SEGMENT_7:
	ldi temp, (ZAHL_7)
	ret
FUNKTION_7_SEGMENT_8:
	ldi temp, (ZAHL_8)
	ret
FUNKTION_7_SEGMENT_9:
	ldi temp, (ZAHL_9)
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
NULLSTELLENUNTERDRUECKUNG:

	cpi temp8,(ZAHL_0)
	brne NULL_FERTIG
	ldi temp8,(ZEICHEN_AUS)

	cpi temp7,(ZAHL_0)
	brne NULL_FERTIG
	ldi temp7,(ZEICHEN_AUS)

	cpi temp6,(ZAHL_0)
	brne NULL_FERTIG
	ldi temp6,(ZEICHEN_AUS)

	cpi temp5,(ZAHL_0)
	brne NULL_FERTIG
	ldi temp5,(ZEICHEN_AUS)

	cpi temp4,(ZAHL_0)
	brne NULL_FERTIG
	ldi temp4,(ZEICHEN_AUS)

	cpi temp3,(ZAHL_0)
	brne NULL_FERTIG
	ldi temp3,(ZEICHEN_AUS)

	cpi temp2,(ZAHL_0)
	brne NULL_FERTIG
	ldi temp2,(ZEICHEN_AUS)

	cpi temp1,(ZAHL_0)
	brne NULL_FERTIG
	ldi temp1,(ZAHL_0)

NULL_FERTIG:

ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	

