; ##############################################################################
; ##############################################################################
; ##############################################################################
; SENSORBELEGUNG TSIC-206														
.equ TSIC_DDR			= DDRD
.equ TSIC_PORT			= PORTD
.equ TSIC_PIN			= PIND
.equ TSIC_PIN_NR		= 6

; ##############################################################################
; ##############################################################################
; ##############################################################################
TSIC_INITIALISIERUNG:
	cbi (TSIC_DDR) ,(TSIC_PIN_NR)					; auf EINGANG	
	cbi (TSIC_PORT),(TSIC_PIN_NR)					; PULL-UP aus   
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TSIC_MESSUNG:
	rcall TSIC_MESSUNG_EINZELN_TEMP1_TEMP2
	mov XL,temp1
	mov XH,temp2
	rcall TSIC_MESSUNG_EINZELN_TEMP1_TEMP2
	cp XL,temp1
	brne TSIC_MESSUNG
	cp XH,temp2
	brne TSIC_MESSUNG
;-------------------------------------------------------------------------------
	; BERECHNUNG Temperatur	
	STS(adr_TSIC_TEMPERATUR_L),NULL
	STS(adr_TSIC_TEMPERATUR_H),NULL
	rcall TSIC_TEMPERATUR_BERECHNUNG	; inp/out temp1+2	
	STS(adr_TSIC_TEMPERATUR_L),temp1
	STS(adr_TSIC_TEMPERATUR_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TSIC_MESSUNG_EINZELN_TEMP1_TEMP2:
	; INITIALISIERUNG		
	clr temp1							; Temperatur	
	clr temp2							; Temperatur	
	clr temp6							; PARITT		
	clr temp8 							; STROBE		
	clr temp9							; Impulslnge	
;-------------------------------------------------------------------------------
	; sendet Sensor DATEN ?	(nach Pegelwechsel suchen)	
	rcall TSIC_DATEN_SUCHEN_TEMP		; OUT temp
	tst temp
	brne TSIC_DATEN_OK
	; ERROR (keine DATEN)	
	cbi (LED_ROT_PORT) ,(LED_ROT_PIN_NR)		; ROT  an	
	ret
;-------------------------------------------------------------------------------
TSIC_DATEN_OK:
	; PUNKT an				
	LDS temp,(adr_LED_BYTE_3)
	ori temp,0b10000000
	STS(adr_LED_BYTE_3),temp
	; kurze Pause (bis maximal ca. 90ms Abstand Datenpakete) 		
	rcall wait_20ms
	rcall wait_20ms
	; PUNKT	aus				
	LDS temp,(adr_LED_BYTE_3)
	andi temp,0b01111111
	STS(adr_LED_BYTE_3),temp
;-------------------------------------------------------------------------------
;	CLI	; INTERRUPTS sperren
;	rcall SEGMENT7_OFF
;-------------------------------------------------------------------------------
	; START-BIT (STROBE) 		; Strobe 16->1MHz				
	rcall TSIC_PIN_ABFRAGEN		; out temp/temp9				
	STS(adr_TSIC_STROBE),temp9	; STROBE speichern im SRAM		
	mov temp8,temp9				; STROBE speichern im Register	
	; Fehlerprfung (STROBE)				
	cpi temp8,5
	brlo TSIC_MESSUNG_EINZELN_TEMP1_TEMP2	; nochmal messen !
	cpi temp8,50
	brsh TSIC_MESSUNG_EINZELN_TEMP1_TEMP2	; nochmal messen !
;-------------------------------------------------------------------------------
	clr temp1
	clr temp2
	; Bit-7 (MSB)	
	rcall TSIC_PIN_ABFRAGEN		; out temp/temp9	
	tst temp					; BIT-7 muss NULL ein
	brne TSIC_MESSUNG_EINZELN_TEMP1_TEMP2	; nochmal messen !
	LSL temp					; Logisch links    --> C rollt raus	  
	ROL temp2					; links ber Carry --> C reinschieben 
	; Bit-6			
	rcall TSIC_PIN_ABFRAGEN		; out temp/temp9	
	tst temp					; BIT-6 muss NULL ein
	brne TSIC_MESSUNG_EINZELN_TEMP1_TEMP2	; nochmal messen !
	LSL temp
	ROL temp2
	; Bit-5			
	rcall TSIC_PIN_ABFRAGEN		; out temp/temp9	
	tst temp					; BIT-5 muss NULL ein
	brne TSIC_MESSUNG_EINZELN_TEMP1_TEMP2	; nochmal messen !
	LSL temp
	ROL temp2
	; Bit-4			
	rcall TSIC_PIN_ABFRAGEN		; out temp/temp9	
	tst temp					; BIT-4 muss NULL ein
	brne TSIC_MESSUNG_EINZELN_TEMP1_TEMP2	; nochmal messen !
	LSL temp
	ROL temp2
	; Bit-3			
	rcall TSIC_PIN_ABFRAGEN		; out temp/temp9	
	LSL temp
	ROL temp2
	; Bit-2			
	rcall TSIC_PIN_ABFRAGEN		; out temp/temp9	
	LSL temp
	ROL temp2
	; Bit-1			
	rcall TSIC_PIN_ABFRAGEN		; out temp/temp9	
	LSL temp
	ROL temp2
	; Bit-0	(LSB)	
	rcall TSIC_PIN_ABFRAGEN		; out temp/temp9	
	LSL temp
	ROL temp2
	; PARITY-BIT	
	rcall TSIC_PIN_ABFRAGEN		; out temp/temp9	
;-------------------------------------------------------------------------------
	; PARITTS-PRFUNG		
	mov temp6,temp2
	rcall TSIC_PARITAET_BERECHNEN_TEMP6	; inp/out: temp6
	cp temp6,temp
	breq TSIC_P1_OK
	rjmp TSIC_MESSUNG_EINZELN_TEMP1_TEMP2	; nochmal messen !
TSIC_P1_OK:
;-------------------------------------------------------------------------------
	; START-BIT	(DUMMY)	
	rcall TSIC_PIN_ABFRAGEN		; out temp/temp9	
	; Bit-7 (MSB)		
	rcall TSIC_PIN_ABFRAGEN		; out temp/temp9	
	LSL temp
	ROL temp1
	; Bit-6			
	rcall TSIC_PIN_ABFRAGEN		; out temp/temp9	
	LSL temp
	ROL temp1
	; Bit-5			
	rcall TSIC_PIN_ABFRAGEN		; out temp/temp9	
	LSL temp
	ROL temp1
	; Bit-4			
	rcall TSIC_PIN_ABFRAGEN		; out temp/temp9	
	LSL temp
	ROL temp1
	; Bit-3			
	rcall TSIC_PIN_ABFRAGEN		; out temp/temp9	
	LSL temp
	ROL temp1
	; Bit-2			
	rcall TSIC_PIN_ABFRAGEN		; out temp/temp9	
	LSL temp
	ROL temp1
	; Bit-1			
	rcall TSIC_PIN_ABFRAGEN		; out temp/temp9	
	LSL temp
	ROL temp1
	; Bit-0	(LSB)	
	rcall TSIC_PIN_ABFRAGEN		; out temp/temp9	
	LSL temp
	ROL temp1
	; PARITY-BIT	
	rcall TSIC_PIN_ABFRAGEN		; out temp/temp9	
;-------------------------------------------------------------------------------
	SEI	; INTERRUPTS FREIGEBEN
;-------------------------------------------------------------------------------
	; PARITTS-PRFUNG		
	mov temp6,temp1
	rcall TSIC_PARITAET_BERECHNEN_TEMP6	; inp/out: temp6
	cp temp6,temp
	breq TSIC_P2_OK
	rjmp TSIC_MESSUNG_EINZELN_TEMP1_TEMP2	; nochmal messen !
TSIC_P2_OK:
;-------------------------------------------------------------------------------
	; ERROR TEMPERATUR (LOW)	
	tst temp1
	brne TSIC_TEMPERATUR_LOW_OK
	tst temp2
	brne TSIC_TEMPERATUR_LOW_OK
	rjmp TSIC_MESSUNG_EINZELN_TEMP1_TEMP2	; nochmal messen !
TSIC_TEMPERATUR_LOW_OK:
;-------------------------------------------------------------------------------
	; ERROR TEMPERATUR (HIGH)	
	cpi temp2,HIGH(0x7FF)
	brlo TSIC_TEMPERATUR_HIGH_OK
	breq TSIC_TEMPERATUR_HIGH_w
	brsh TSIC_TEMPERATUR_HIGH_ERROR
TSIC_TEMPERATUR_HIGH_w:
	cpi temp1,LOW (0x7FF)
	brlo TSIC_TEMPERATUR_HIGH_OK
	breq TSIC_TEMPERATUR_HIGH_ERROR
	brsh TSIC_TEMPERATUR_HIGH_ERROR
TSIC_TEMPERATUR_HIGH_ERROR:
	rjmp TSIC_MESSUNG_EINZELN_TEMP1_TEMP2	; nochmal messen !
TSIC_TEMPERATUR_HIGH_OK:
;-------------------------------------------------------------------------------
	ret
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; OUT: temp																		
; nach einem Pegelwechsel suchen												
TSIC_DATEN_SUCHEN_TEMP:
	; SCHLEIFE					
	clr temp1
	clr temp2
	ldi temp3,10
TSIC_DATEN_SUCHEN_L:
	WDR
	dec temp1
	brne TSIC_DATEN_SUCHEN_L_W
	dec temp2
	brne TSIC_DATEN_SUCHEN_L_W
	dec temp3
	brne TSIC_DATEN_SUCHEN_L_W
	; ERROR			
	clr temp
	ret
TSIC_DATEN_SUCHEN_L_W:
	sbic (TSIC_PIN),(TSIC_PIN_NR)        ; "skip if bit ..."
	rjmp TSIC_DATEN_SUCHEN_L
;-------------------------------------------------------------------------------
	; SCHLEIFE					
	clr temp1
	clr temp2
	ldi temp3,10
	; SCHLEIFE					
TSIC_DATEN_SUCHEN_H:
	WDR
	dec temp1
	brne TSIC_DATEN_SUCHEN_H_W
	dec temp2
	brne TSIC_DATEN_SUCHEN_H_W
	dec temp3
	brne TSIC_DATEN_SUCHEN_H_W
	; ERROR			
	clr temp
	ret
TSIC_DATEN_SUCHEN_H_W:
	sbis (TSIC_PIN),(TSIC_PIN_NR)        ; "skip if bit ..."
	rjmp TSIC_DATEN_SUCHEN_H	
;-------------------------------------------------------------------------------
	; Freigabe		
	ldi temp,1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: temp8 (STROBE) 															
; OUT: temp  																	
;	   temp9(Impulslnge)														
TSIC_PIN_ABFRAGEN:
	clr temp9
;-------------------------------------------------------------------------------
; Warteschleife, wenn PIN "HIGH" ist			
TSIC_PIN_ABFRAGEN_HIGH_PEGEL:
	sbic (TSIC_PIN),(TSIC_PIN_NR)        ; "skip if bit ..."
	rjmp TSIC_PIN_ABFRAGEN_HIGH_PEGEL
;-------------------------------------------------------------------------------
; Warteschleife, wenn PIN "LOW" ist				
	;CLI	; INTERRUPTS sperren	
TSIC_PIN_ABFRAGEN_LOW_PEGEL:
	inc temp9 								; ZHLER+1
	sbis (TSIC_PIN),(TSIC_PIN_NR)        ; "skip if bit ..."	
	rjmp TSIC_PIN_ABFRAGEN_LOW_PEGEL
	;SEI	; INTERRUPTS freigeben	
;-------------------------------------------------------------------------------
	; VERGLEICH	mit STROBE-WERT					
	cp temp9,temp8
	brlo TSIC_PIN_LOGIC_HIGH
TSIC_PIN_LOGIC_LOW:
	clr temp
	ret
TSIC_PIN_LOGIC_HIGH:
	ldi temp,255
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TSIC_PARITAET_BERECHNEN_TEMP6:
	push temp		; sichern			
	clr temp	

	SBRC temp6,0	; Skip if Bit in Register Cleared
	inc temp		
	SBRC temp6,1
	inc temp
	SBRC temp6,2
	inc temp
	SBRC temp6,3
	inc temp
	SBRC temp6,4
	inc temp
	SBRC temp6,5
	inc temp
	SBRC temp6,6
	inc temp
	SBRC temp6,7
	inc temp

	; AUSWERTUNG	
	clr temp6
	SBRC temp,0
	ldi temp6,255
	pop temp	; wiederherstellen
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: temp1 + temp2															
; OUT: temp1 + temp2															
;===============================================================================
; BERECHNUNG der Temperatur aus den Temperaturdaten								
; Formel:	C = WERT x 2000/2048-500											
;	-50C	   0 (0x000)														
;	-10C	 409 (0x199)														
;	  0C	 512 (0x200)														
;	 25C	 767 (0x2FF)														
;	 60C	1125 (0x465)														
;	125C	1790 (0x6FE)														
;	150C	2047 (0x7FF)														
TSIC_TEMPERATUR_BERECHNUNG:
; TESTZAHL					
;	ldi temp1,LOW (0x000)	
;	ldi temp2,HIGH(0x000)	
;	ldi temp1,LOW (0x465)	
;	ldi temp2,HIGH(0x465)	
;	ldi temp1,LOW (0x7FF)	
;	ldi temp2,HIGH(0x7FF)	
;-------------------------------------------------------------------------------
; mal 2000																		
	LSL temp1		; x 2 (2)		
	ROL temp2
	ROL temp3
	LSL temp1		; x 2 (4)		
	ROL temp2
	ROL temp3
	LSL temp1		; x 2 (8)		
	ROL temp2
	ROL temp3

	mov R0,temp1	; x 250 (2000)	
	mov R1,temp2
	clr temp3
	ldi temp,250-1
TSIC_TEMPERATUR_BERECHNUNG_S:
	add temp1,R0
	adc temp2,R1
	adc temp3,NULL
	dec temp
	brne TSIC_TEMPERATUR_BERECHNUNG_S
;-------------------------------------------------------------------------------
; aufrunden	(halben Devisor dazuaddieren)										
	subi temp1,BYTE1(-1024)
	sbci temp2,BYTE2(-1024)
	sbci temp3,BYTE3(-1024)
	; :2048						
	mov temp1,temp2	; :256
	mov temp2,temp3
	LSR temp2		; :2	
	ROR temp1
	LSR temp2		; :2	
	ROR temp1
	LSR temp2		; :2	
	ROR temp1
;-------------------------------------------------------------------------------
; -500																			
	subi temp1,BYTE1(500)
	sbci temp2,BYTE2(500)
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################



