;												
; Thermometer mit TSIC206						
;												
; LED 4xSA23  7-SEGMENT							
;												
; ATmega8										
; 1 MHz											
;												
; Bernhard.Erfurt@gmx.de						
; 11/2015										
;												


;												
; Anschlussbelegung PINS						
;												
; PB0 ==>LED GELB								
; PB1 ==>LED ROT  (ERROR)						
; PB2 ==>										
; PB3 ==>										
; PB4 ==>										
; PB5 ==>										
; PB6 ==> s.Belegung							
; PB7 ==>										
;												
; PC0 ==> s.Belegung							
; PC1 ==> s.Belegung							
; PC2 ==> s.Belegung							
; PC3 ==> s.Belegung							
; PC4 ==> s.Belegung							
; PC5 ==> s.Belegung							
;												
; PD0 ==> s.Belegung							
; PD1 ==> s.Belegung							
; PD2 ==> s.Belegung							
; PD3 ==> s.Belegung							
; PD4 ==> s.Belegung							
; PD5 ==> 										
; PD6 ==> INP TSIC206							
; PD7 ==> 										
;												


; ATmega8 										
.include "m8def.inc"
; KONSTANTEN									
.equ TAKT						= 1000000			
; TIMER-WERTE (2 hoch 8  minus...)				
.equ TIMERWERT0 				= 256-80	; 80	
; LED-GELB										
.equ LED_GELB_PIN_NR			= 1
.equ LED_GELB_DDR				= DDRB
.equ LED_GELB_PORT				= PORTB
; LED-ROT										
.equ LED_ROT_PIN_NR				= 0
.equ LED_ROT_DDR				= DDRB
.equ LED_ROT_PORT				= PORTB

; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN					=SRAM_START+0		; 0x0060 START Adresse 		

.equ adr_TSIC_STROBE			=SRAM_START+10		; SENSOR-STROBE				
.equ adr_TSIC_TEMPERATUR_L      =SRAM_START+11
.equ adr_TSIC_TEMPERATUR_H 	    =SRAM_START+12

.equ adr_LED_ZAEHLER			=SRAM_START+100
.equ adr_LED_BYTE_0				=SRAM_START+101		; DIGIT (rechts)
.equ adr_LED_BYTE_1				=SRAM_START+102
.equ adr_LED_BYTE_2				=SRAM_START+103
.equ adr_LED_BYTE_3				=SRAM_START+104

.equ adr_SRAM_CHECK				=SRAM_START+943	; SRAM CHECK muss immer "S" sein	

; REGISTER										
.def KOPIE_SREG = R5
.def KOPIE_TEMP = R6
.def NULL 		= R10
.def EINS 		= R11
.def TIMERWERT	= R12

.def temp 		= R16
.def temp1 		= R17
.def temp2 		= R18
.def temp3 		= R19
.def temp4 		= R20
.def temp5 		= R21
.def temp6 		= R22
.def temp7 		= R23
.def temp8 		= R24
.def temp9 		= R25

.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   ; Timer1 Overflow Handler           	
rjmp TIM0_OVF   		; Timer0 Overflow Handler           					
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	; USART RX Complete Handler         					
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI      ; Two-wire Serial Interface Handler 					
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Bei unkorrekten Interrupt									
INTERRUPT_ERROR:
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	cbi (LED_ROT_PORT) ,(LED_ROT_PIN_NR)		; ROT  an	
	rcall WAIT_100ms
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	sbi (LED_ROT_PORT) ,(LED_ROT_PIN_NR)		; ROT  an	
	rcall WAIT_100ms
	rjmp INTERRUPT_ERROR

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM_CLEAR										
	rcall SRAM_CLEAR
; REGISTER_CLEAR									
	rcall REGISTER_CLEAR
; PORT_CLEAR										
	rcall PORT_CLEAR
; TSIC_INITIALISIERUNG								
	rcall TSIC_INITIALISIERUNG
; LED_INITIALISIERUNG								
	rcall LED_INITIALISIERUNG
; WDR_INITIALISIERUNG								
	rcall WDR_INITIALISIERUNG
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
; SEGMENT7_INITIALISIERUNG							
	rcall SEGMENT7_INITIALISIERUNG
; TIMER0_INITIALISIERUNG							
	rcall TIMER0_INITIALISIERUNG
; TIMER_AKTIVIEREN									
	rcall TIMER_AKTIVIEREN
; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; TIMERWERT			
	ldi temp, TIMERWERT0
	mov TIMERWERT,temp
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
; PROGRAMM_CHECK									
	rcall PROGRAMM_CHECK
; interrupts freigeben								
	sei
;-------------------------------------------------------------------------------
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB aus	
	sbi (LED_ROT_PORT) ,(LED_ROT_PIN_NR)		; ROT  aus	

	rcall ANZEIGE_BEGRUESSUNG
	rcall wait_1s
	rcall TSIC_MESSUNG
	rcall ANZEIGE_STROBE_A
	rcall wait_1s
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR		; Watch-Dog-RESET	
	rcall TSIC_MESSUNG
	rcall ANZEIGE_TEMPERATUR
	rcall PROGRAMM_CHECK
	rcall wait_1s
	rcall wait_1s
	rcall wait_1s
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "THERMO_ANZEIGE.asm"
.include "THERMO_TIMER.asm"
.include "THERMO_SONSTIGES.asm"
.include "THERMO_7SEGMENT.asm"
.include "THERMO_7SEGMENT_BELEGUNG4.asm"
.include "THERMO_TSIC206.asm"
.include "THERMO_WAIT_01MHZ.asm"
